import sys
from PyQt4 import QtGui, QtCore
import time
import socket



############################ Main Widgets ############################


class w_time(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 80)
        size = self.size()
        self.w = size.width()
        self.h = size.height()

        self.parent = parent

        self.label1 = QtGui.QLabel("                               ", self)
        self.label1.move(15, 17)
        self.label2 = QtGui.QLabel("                                       ", self)
        self.label2.move(55, 57)
        self.label3 = QtGui.QLabel("<b>Time:", self)
        self.label3.move(86, 5)

        serifFont =QtGui.QFont("Verdana", 25)
        self.label1.setFont(serifFont)

        serifFont2 =QtGui.QFont("Verdana", 10)
        self.label2.setFont(serifFont2)
        self.label3.setFont(serifFont2)

    def paintEvent(self, event):

        self.time2 = time.strftime('%H:%M:%S')
        self.label1.setText("<b>" +str(self.time2))
        self.label2.setText(self.parent.time_sting + "  x " +str(self.parent.speed))

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, self.w-1, self.h-1)
        paint.end()

class w_Score(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(700, 200)
        self.parent = parent
        self.session = session

        self.labelr = QtGui.QLabel('Testsubject Number:' + str(session.number), self)
        self.labelr.move(720, 35)

        self.inputnr = QtGui.QLineEdit('0', self)
        self.inputnr.move(830, 30)
        self.inputnr.resize(30, 26)

        self.b1 = QtGui.QPushButton('Save Data', self)
        self.b1.setGeometry(870, 30, 100, 26)
        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.parent.saveData)


        self.label0 = QtGui.QLabel('<b>Simulation Score', self)
        self.label0.move(15, 5)
        self.label1 = QtGui.QLabel('                                                                   ' + str(session.number), self)
        self.label1.move(10, 30)
        self.label2 = QtGui.QLabel('                                                                   '+ str(session.patientName), self)
        self.label2.move(10, 44)
        self.label3 = QtGui.QLabel('                                                                                                                                    ', self)
        self.label3.move(10, 58)
        self.label4 = QtGui.QLabel('                                                                   '+ session.time_sting, self)
        self.label4.move(10, 72)

        self.labelA1 = QtGui.QLabel('yy', self)
        self.labelA1.move(10, 90)
        self.labelA1.resize(1000, 20)

        self.labelA2 = QtGui.QLabel('yy', self)
        self.labelA2.move(10, 95)
        self.labelA2.resize(1000, 50)

        self.labelA3 = QtGui.QLabel('yy', self)
        self.labelA3.move(10, 120)
        self.labelA3.resize(1000, 50)

        self.labelA4 = QtGui.QLabel('yy', self)
        self.labelA4.move(10, 150)
        self.labelA4.resize(1000, 50)

    def paintEvent(self, event):

        avg_score= "Error"
        if self.session.session_time>0:
          avg_score = self.session.score*1.00/self.session.session_time*1.00
          avg_score = round(avg_score,3)
          avg_score = "%3.3f" % avg_score

        ttime = self.session.session_time - self.session.score_time

        self.label1.setText('Goal Min: ' + str(self.session.sudMax) + "   time:" + str(ttime) )
        self.label2.setText('Goal Max: '+ str(self.session.sudMin))
        self.label3.setText('State: ' + self.session.state + "                   Levels: " + self.parent.simulationCreator.levels) #'Low(-1) good(+1) High (-1) Ignoring(-2)'
        self.label4.setText('Score: '+ str(self.session.score) + "    Avg: " + avg_score)
        self.labelA1.setText( str(self.session.GetEaArrayString()) )

        self.labelA2.setText("Correct: " + str(self.session.correct)+"   Errors: " + str(self.session.error) )


        self.labelA3.setText(self.parent.sessionControl.scoreSting() )

        self.labelA4.setText(self.parent.sessionControl.data )

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()


class w_ControlInfo(QtGui.QLabel):
    def __init__(self, parent, sc):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)

        size = self.size()
        w = size.width()
        h = size.height()
        self.parent = parent
        self.sessionControl = sc

        self.label0 = QtGui.QLabel("<b>Info", self)
        self.label0.move(15, 5)

        #self.textEdit = QtGui.QTextEdit()
        self.ListView = QtGui.QListWidget(self)
        self.ListView.move(10, 23)
        #self.ListView.show()
        #self.ListView.addItem ("fff")

        #newItem = QtGui.QListWidgetItem()
        #newItem.setText("tt")
        #self.ListView.insertItem(0, newItem)
        #newItem.setText("tffffft")
        self.i=0

        self.selected = 0

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()


        self.ListView.resize(w-21,h-32)

        #add new
        if self.i<>len(self.sessionControl.sessionArray):

            self.ListView.clear()

            for i in range(len(self.sessionControl.sessionArray)):

                ss = str(i) + "|  " + self.sessionControl.sessionArray[i].getSting()

                newItem = QtGui.QListWidgetItem()
                newItem.setText(ss)
                newItem.rrr = i
                self.ListView.addItem(newItem)

            self.i = len(self.sessionControl.sessionArray)

        #update
        for i in range(len(self.sessionControl.sessionArray)):
            ss = str(i) + "|  " + self.sessionControl.sessionArray[i].getSting()
            self.ListView.item(i).setText(ss)
            #self.ListView.item(i).setText(str(self.ListView.currentRow()))

        self.selected = self.ListView.currentRow()


        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_ConnectionControl(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 280)
        self.parent = parent
        self.port =2000
        self.label1 = QtGui.QLabel('<b>Connection Control', self)
        self.label1.move(50, 8)

        self.b1_timer=0

        self.label3 = QtGui.QLabel('Host:', self)
        self.label3.move(25, 37)

        temp = str(socket.gethostbyname(socket.gethostname()))
        self.input_host = QtGui.QLineEdit(temp, self)
        self.input_host.move(60, 30)
        self.input_host.resize(120, 26)


        self.label4 = QtGui.QLabel('Port:', self)
        self.label4.move(25, 67)

        self.input_port = QtGui.QLineEdit('2000', self)
        self.input_port.move(60, 60)
        self.input_port.resize(60, 26)

        self.checkBox = QtGui.QCheckBox(self)
        self.checkBox.setGeometry(430,60,100,26)
        self.checkBox.setText("send")
        self.checkBox.setChecked(True)

        self.b1 = QtGui.QPushButton('Open Connection', self)
        self.b1.setGeometry(20, 90, 160, 26)
        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.parent.addConnection)



        self.ListView = QtGui.QListWidget(self)
        self.ListView.move(20, 120)
        self.ListView.resize(160, 150)

        self.i = 0


        self.B3 = QtGui.QPushButton('-', self)
        self.B3.setGeometry(125, 60, 25, 26)
        self.connect(self.B3, QtCore.SIGNAL('clicked()'), self.down)

        self.B4 = QtGui.QPushButton('+', self)
        self.B4.setGeometry(155, 60 , 25, 26)
        self.connect(self.B4, QtCore.SIGNAL('clicked()'), self.up)


    def up(self):
        self.port= self.port + 2

    def down(self):
        self.port= self.port - 2


    def paintEvent(self, event):

        self.input_port.setText(str(self.port))

        #add new
        if self.i<>len(self.parent.ConnectionsInArray):

            self.ListView.clear()

            for i in range(len(self.parent.ConnectionsInArray)):

                ss = str(i) + ":" + self.parent.ConnectionsOutArray[i].getString()
                ss=ss+ "\n" + str(i) + ":" + self.parent.ConnectionsInArray[i].getString()
                newItem = QtGui.QListWidgetItem()
                newItem.setText(ss)
                newItem.rrr = i
                self.ListView.addItem(newItem)

            self.i = len(self.parent.ConnectionsInArray)

        #update
        for i in range(len(self.parent.ConnectionsInArray)):
            ss = str(i) + ":" + self.parent.ConnectionsOutArray[i].getString()
            ss=ss+ "\n" + str(i) + ":" + self.parent.ConnectionsInArray[i].getString()
            self.ListView.item(i).setText(ss)
            #self.ListView.item(i).setText(str(self.ListView.currentRow()))

        self.selected = self.ListView.currentRow()

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()


class w_WindowControl(QtGui.QLabel):
    def __init__(self, parent, sessioncontrol):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 190)
        self.parent = parent
        self.sessioncontrol = sessioncontrol

        self.label1 = QtGui.QLabel('<b>Session Control', self)
        self.label1.move(62, 10)

        self.b1_timer=0

        self.b1 = QtGui.QPushButton('Normal Simulation', self)
        self.b1.setGeometry(20, 30, 160, 26)
        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.parent.ceateSimulation)
        self.b2 = QtGui.QPushButton('Assist Simulation', self)
        self.b2.setGeometry(20, 60, 160, 26)
        self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.parent.ceateSimulationAssist)
        self.b3 = QtGui.QPushButton('Reset', self)
        self.b3.setGeometry(20, 120, 160, 26)
        self.connect(self.b3, QtCore.SIGNAL('clicked()'), self.parent.reset)

        self.b4 = QtGui.QPushButton('Prac. norm ', self)
        self.b4.setGeometry(20, 90, 75, 26)
        self.connect(self.b4, QtCore.SIGNAL('clicked()'), self.parent.ceateTestSimulation)

        self.b5 = QtGui.QPushButton('Prac. Assit', self)
        self.b5.setGeometry(105, 90, 75, 26)
        self.connect(self.b5, QtCore.SIGNAL('clicked()'), self.parent.ceateTestSimulationAssist)

        self.b6 = QtGui.QPushButton('Start Simulation', self)
        self.b6.setGeometry(20, 150, 160, 26)
        self.connect(self.b6, QtCore.SIGNAL('clicked()'), self.parent.sessionControl.startSimulation)






    def paintEvent(self, event):


        if self.parent.sessionControl.assist == True:
         self.b2.setText(">>> Assist Simulation <<<")
         self.b1.setText("Normal Simulation")
        else:
         self.b2.setText("Assist Simulation")
         self.b1.setText(">>> Normal Simulation <<<")

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_SessionTimeline2(QtGui.QLabel):
    def __init__(self, parent, session, mode):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(500, 230)
        size = self.size()
        w = size.width()
        h = size.height()
        self.mode=mode
        self.parent = parent
        self.session = session

        self.scale = 1 # scale

        #addsesion
        self.b1 = QtGui.QPushButton('Add VR-Senario', self)
        self.b1.setGeometry(5, 145, 140, 32)
        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.session.update)

        #sud label
        self.label1 = QtGui.QLabel(str(session.sud)+"    ", self)
        self.label1.move(10, 10)
        serifFont =QtGui.QFont("Verdana", 25)
        self.label1.setFont(serifFont)
        self.label1.resize(200,100)

        #time label
        self.label_time = QtGui.QLabel("  0:00:00", self)

        self.grid = QtGui.QImage()
        self.lastFlag = -100
        self.up = 0

    def paintEvent(self, event):

        #dimentioning
        size = self.size()
        w = size.width()
        h = size.height()
        i=0
        space= w-160.0
        tst = self.session.session_time_total

        step=(space/tst)
        self.scale = step
        rr = (self.scale*self.session.i)-self.scale+1

        #paint All
        paint = QtGui.QPainter()
        paint.begin(self)

        self.grid = QtGui.QImage()
        self.grid.load("res/bar.jpg")
        target = QtCore.QRectF(0, 20, w-1, 99)

        paint.drawImage(target,self.grid)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 20, w-1, 99)


        paint.setPen(QtGui.QColor(220, 220, 220))
        paint.drawLine(1, 120-(self.session.sudMax*10), rr, 120-(self.session.sudMax*10))
        paint.drawLine(1, 120-(self.session.sudMin*10), rr, 120-(self.session.sudMin*10))

        pen = QtGui.QPen(QtCore.Qt.black, 2, QtCore.Qt.SolidLine)
        paint.setPen(pen)

        for i in range(self.session.i-1):
            t = 10*self.session.history[i]
            tt = 10*self.session.history[i+1]
            paint.drawLine(i*self.scale, 120-t, i*self.scale+self.scale, 120-tt)

        paint.setPen(QtGui.QColor(255, 255, 255))
        paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 120, w-1, 10)

        j = 0
        self.num = [0.25, 0.5, 0.75, 1.0]
        step=int(space/4)
        pen = QtGui.QPen(QtCore.Qt.black, 2, QtCore.Qt.SolidLine)
        paint.setPen(pen)

        for i in range(step, 5*step, step):
            paint.drawLine(i, 120, i, 124)
            metrics = paint.fontMetrics()
            tempst = self.session.Give_time_sting(self.session.session_time_total,self.num[j])
            fw = metrics.width(tempst)
            paint.drawText(i-fw/2, 136, tempst)
            j = j + 1

        paint.setBrush(QtGui.QColor(192, 192, 255))
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 139, rr-3, 40)


        #flag
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 218, w-1, 2)

        #self.ttt = QtGui.QPixmap("res/Patient_view.jpg")
        #self.buffer = QPixmap()
        #bitBlt(self, 0, 0, temp)
        #paint.drawImage(0,0, self.ttt)


        #info
        if self.mode==0:
          self.lastFlag = -12
  
          for i in range(len(self.session.flagArray)):
            flag = self.session.flagArray[i]
            tt = flag.time
            tt=int(tt*self.scale)
            ttt=tt
            self.up = tt
  
            if (tt - self.lastFlag )<22:
              tt = self.lastFlag + 22
              self.lastFlag = tt
  
            #else:
            #  self.lastFlag = tt
            #if i ==0:
            #  self.up=0
  
            #self.lastFlag = tt
            else:
              self.lastFlag = tt
  
  
            paint.drawLine(ttt,216, tt, 204)
  
            self.grid = QtGui.QImage()
            self.grid.load(flag.update())
            target = QtCore.QRectF(tt-10,185, 20, 20)
            paint.drawImage(target,self.grid)
  
  
            self.grid = QtGui.QImage()
            self.grid.load("res/bol.png")
            target = QtCore.QRectF(ttt-3,216, 7, 7)
            paint.drawImage(target,self.grid)
  
            #self.grid.load("res/flag.png")

        #info2
        if self.mode==1:
          self.lastFlag = -12

          for i in range(len(self.session.sim.adjustArray)):
            flag = self.session.sim.adjustArray[i]
            tt = flag.goTime
            tt=int(tt*self.scale)
            ttt=tt
            self.up = tt
  
            if (tt - self.lastFlag )<22:
              tt = self.lastFlag + 22
              self.lastFlag = tt

            #else:
            #  self.lastFlag = tt
            #if i ==0:
            #  self.up=0
  
            #self.lastFlag = tt
            else:
              self.lastFlag = tt
  

            paint.drawLine(ttt,216, tt, 204)
  
            self.grid = QtGui.QImage()
            self.grid.load("res/flag.png")

            self.grid2 = QtGui.QImage()
            self.grid2.load("res/flag2.png")

            self.grid3 = QtGui.QImage()
            self.grid3.load("res/flag3.png")

            self.grid4 = QtGui.QImage()
            self.grid4.load("res/flag4.png")

            self.grid5 = QtGui.QImage()
            self.grid5.load("res/flag5.png")

            target = QtCore.QRectF(tt-10,185, 20, 20)

            if flag.code =="SET":
                paint.drawImage(target,self.grid3)
            elif flag.code =="ASKWORKLOAD":
                paint.drawImage(target,self.grid4)
            elif flag.code =="LEVEL":
                paint.drawImage(target,self.grid5)
            elif flag.code =="D":
                paint.drawImage(target,self.grid2)
            else:
                paint.drawImage(target,self.grid)
  
            self.grid = QtGui.QImage()
            self.grid.load("res/bol.png")
            target = QtCore.QRectF(ttt-3,216, 7, 7)
            paint.drawImage(target,self.grid)

          #self.grid.load("res/flag.png")

        #bar
        pen = QtGui.QPen(QtCore.Qt.red, 2, QtCore.Qt.SolidLine)
        paint.setPen(pen)
        paint.drawLine(rr, 17, rr, 225)



        paint.end()

        #adjust labels and buttons
        st_s=str(round(self.session.sud2,1))
        if len(st_s)==1:
         st_s = st_s + ".0"
        self.label1.setText("<font color=black size=100><b>"+ st_s +"</b>")
        self.label1.move(5+rr, 16)

        self.label_time.setText(self.session.time_sting)
        self.label_time.move(rr-19, 2)

        self.b1.setGeometry(5+rr, 145, 130, 32)


#general Widets



class w_view(QtGui.QLabel):
    def __init__(self, parent, image, name):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.label0 = QtGui.QLabel("<b><center>" +name, self)
        self.label0.move(0, 2)
        self.label0.resize(w,20)

        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(20, 25)
        self.label.setPixmap(self.image)

        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)




    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()
    
        self.label0.resize(w,20)
        self.label.resize(w-42,h-42)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()



######basic widgetes

class w_white(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(1, 30)
        self.parent = parent

    def paintEvent(self, event): 

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(255, 255, 255))
        paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 0, w, h)
        paint.end()


class w_Image(QtGui.QLabel):
    def __init__(self, parent, image):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(1, 1)
        self.label.setPixmap(self.image)

        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        self.label.resize(w-2,h-2)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_Movie(QtGui.QLabel):
    def __init__(self, parent, image):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(100, 100)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.scale = 1
        self.label = QtGui.QLabel("    ", self)
        self.label.move(0, 0)

        self.label.resize(w-1,h-1)

        self.mov = QtGui.QMovie("mov/globe.gif")
        self.mov.start()

        self.mov.setSpeed(800)

        self.label.setMovie(self.mov)


        #self.label.setScaledContents(True)
        #self.label.resize(w-1,h-1)

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        self.label.resize(w-1,h-1)

        #self.mov.jumpToNextFrame()
        #self.label.setMovie(self.mov)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        #paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()
