
import random
import time

from SessionStore import *

class SessionControl():    #Control
    # Always remember the *self* argument
    def __init__(self, parent):

        #sesion time
        self.data = ""
        self.level = 0
        self.assist = False
        self.parent = parent
        self.simulation_time = 0
        self.simulation_total_time = 30*60
        self.time_sting = "0:00:00"
        self.time_sting_total = "0:30:00"

        self.d1n = "1n; ; ; ; ; ;;"
        self.d2n = "2n; ; ; ; ; ;;"
        self.d3n = "3n; ; ; ; ; ;;"
        self.d4n = "4n; ; ; ; ; ;;"
        self.d1a = "1a; ; ; ; ; ;;"
        self.d2a = "2a; ; ; ; ; ;;"
        self.d3a = "3a; ; ; ; ; ;;"
        self.d4a = "4a; ; ; ; ; ;;"


        self.sessionArray = []
        self.numberOfSessions = 0
        self.maxnumberOfSessions = 0

        self.speed = 1

    def update(self):

        self.simulation_time = self.simulation_time +1

        for i in range(len(self.sessionArray)):
            if self.sessionArray[i].status=="Pauze":
                self.sessionArray[i].update()


    def reset(self):
        #sesion time
        self.simulation_time = 0
        self.simulation_total_time = 30*60
        self.time_sting = "0:00:00"
        self.time_sting_total = "0:30:00"

        self.sessionArray = []
        self.assist = False

        self.parent.selectedSession = SessionStore(self, -1, "A","<none>", "", "<none>",-1)  #empty


        #for i in range(len(self.sessionArray)):
        #    self.sessionArray[i].reset()

    def startSimulation(self):
        self.sessionArray[0].sessionStart()
        self.sessionArray[1].sessionStart()
        self.sessionArray[2].sessionStart()

    def addNewSession(self, session):
        self.sessionArray.append(session)
        return len(self.sessionArray)-1

    def continueToSession(self,i,ii):
        conn = self.sessionArray[i].connectionIndex
        self.sessionArray[ii].connectionIndex = conn
        self.parent.commandOut("SWITCH",  conn)
        self.sessionArray[ii].startIn = 5*60
        self.sessionArray[i].connectionIndex= -1

    def firstConnection(self, c):
        for i in range(len(self.sessionArray)):
            if self.sessionArray[i].connectionIndex==c and self.sessionArray[i].initialized==False:
                self.sessionArray[i].sendInfo()
                self.sessionArray[i].initialized = True  

    def connectToSession(self,sessionnmber):
        temp = self.sessionArray[sessionnmber]
        return temp

    def resetScore(self):        

        for i in range(len(self.sessionArray)):

            self.sessionArray[i].error = 0
            self.sessionArray[i].correct = 0
            self.sessionArray[i].workload = -1
            self.sessionArray[i].RemoteAssist = 0


            self.sessionArray[i].score = 0
            self.sessionArray[i].score_time = self.sessionArray[i].score_time + 5*60
            self.sessionArray[i].eaArray = []

            self.sessionArray[i].avg_response = 0

            #self.sessionArray[i].avg_score = 0
            #self.sessionArray[i].avg_response = 0




    def scoreSting(self):

        score = "Level: \tAssist: \tScore: \tResp.Time: \tCorr: \tPanicB: \tWorkLoad: \t \n"

        #for i in range(len(self.sessionArray)):
        #    score = score + " [ " + str(self.sessionArray[i].level) + " ] - "

        if len(self.sessionArray) > 0:
            score = score + str(self.level) + "\t"
        else:
            score = score + "0\t"

        if  self.assist == False:
            score = score + "No \t"
        else:
            score = score + "Yes \t"

        t=0
        err = 0
        corr = 0
        ra=0
        rt=0
        wl =-1
        for i in range(len(self.sessionArray)):
            t =t + self.sessionArray[i].avg_score
            err = err + self.sessionArray[i].error
            corr = corr + self.sessionArray[i].correct
            ra = ra + self.sessionArray[i].RemoteAssist
            rt = rt + self.sessionArray[i].avg_response

            if self.sessionArray[i].workload>-1:
                wl= self.sessionArray[i].workload

        t=t/3.0
        t = "%3.2f" % t
        pp=3
        if len(self.sessionArray) == 3:
          if self.sessionArray[0].avg_response==0:
            pp = pp -1
          if self.sessionArray[1].avg_response==0:
            pp = pp -1
          if self.sessionArray[2].avg_response==0:
            pp = pp -1

        if pp==0:
            pp=1

        rt=rt/pp
        rt = str(int(rt))

        corr = corr +1 
        err = err+corr

        corr = corr*1.0/err*1.0
        corr = "%3.2f" % corr

        score = score + t + "% \t"

        score = score + rt + " sec. \t"

        score = score + corr + "% \t"

        score = score + str(ra) + " \t"

        score = score + str(wl) + " "

        tempdata =   t +";" + rt + ";" + corr + ";" + str(ra) + ";" + str(wl) + ";;"



        if self.level == 1 and self.assist == False:
            self.d1n = "1n;" +  tempdata
        if self.level == 2 and self.assist == False:
            self.d2n = "2n;" +  tempdata
        if self.level == 3 and self.assist == False:
            self.d3n = "3n;" +  tempdata
        if self.level == 4 and self.assist == False:
            self.d4n = "4n;" +  tempdata
        if self.level == 1 and self.assist == True:
            self.d1a = "1a;" +  tempdata
        if self.level == 2 and self.assist == True:
            self.d2a = "2a;" +  tempdata
        if self.level == 3 and self.assist == True:
            self.d3a = "3a;" +  tempdata
        if self.level == 4 and self.assist == True:
            self.d4a = "4a;" +  tempdata


        self.data=  self.d1n + self.d2n + self.d3n+ self.d4n + self.d1a + self.d2a + self.d3a + self.d4a



        return score

    def Give_time_sting(self,sec,scale):
        tst = sec*scale
        ts = int(tst)
        tm=int((tst /60))
        th=int((tst /(60*60)))
        tm=tm-(th*60)
        ts=ts-(tm*60)-(th*60*60)
        self.st_s=str(ts)
        if len(self.st_s)==1:
         self.st_s = "0"+str(ts)
        self.st_m=str(tm)
        if len(self.st_m)==1:
         self.st_m = "0"+str(tm)
        time_sting_total=str(th)+":"+self.st_m+":"+self.st_s
        return time_sting_total







