import sys
from PyQt4 import QtGui, QtCore
import time
import socket

############################ Therapist Window widgets ############################

class w_SessionStart(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 170)
        self.parent = parent

        self.label0 = QtGui.QLabel('<b>Session Information', self)
        self.label0.move(15, 5)

        self.label1 = QtGui.QLabel('' , self)
        self.label1.move(10, 30)

        self.B_start = QtGui.QPushButton('Create A new session', self)
        self.B_start.setGeometry(30, 30, 140, 26)
        self.connect(self.B_start, QtCore.SIGNAL('clicked()'), self.new)

        self.B_sim = QtGui.QPushButton('Simulation Mode', self)
        self.B_sim.setGeometry(30, 130, 140, 26)
        self.connect(self.B_sim, QtCore.SIGNAL('clicked()'), self.sim)



    def new(self):
        self.parent.StartNewSession()

    def sim(self):
        #self.parent.StartNewSession()
        self.parent.simMode = True
        self.parent.noSession=False
        self.close()



    def paintEvent(self, event):

        if self.parent.connected<>"Connected":
            self.B_start.setEnabled(False)
            self.B_sim.setEnabled(False)
        else:
            self.B_start.setEnabled(True)
            self.B_sim.setEnabled(True)


        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_Connection(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 120)
        self.parent = parent
        self.port= 2000

        self.label1 = QtGui.QLabel('<b>Connection:', self)
        self.label1.move(15, 5)

        self.label2 = QtGui.QLabel('                            ', self)
        self.label2.move(87, 5)

        self.b1_timer=0

        self.label3 = QtGui.QLabel('Host:', self)
        self.label3.move(25, 32)


        temp = str(socket.gethostbyname(socket.gethostname()))   
        self.input_host = QtGui.QLineEdit(temp, self)
        self.input_host.move(60, 25)
        self.input_host.resize(120, 26)


        self.label4 = QtGui.QLabel('Port:', self)
        self.label4.move(25, 62)

        self.input_port = QtGui.QLineEdit('2000', self)
        self.input_port.move(60, 55)
        self.input_port.resize(60, 26)

        #self.checkBox = QtGui.QCheckBox(self)
        #self.checkBox.setGeometry(130,55,100,26)
        #self.checkBox.setText("send")


        self.b1 = QtGui.QPushButton('Open Connection', self)
        self.b1.setGeometry(20, 85, 160, 26)
        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.parent.addConnection)

        self.B3 = QtGui.QPushButton('-', self)
        self.B3.setGeometry(125, 55, 25, 26)
        self.connect(self.B3, QtCore.SIGNAL('clicked()'), self.down)

        self.B4 = QtGui.QPushButton('+', self)
        self.B4.setGeometry(155, 55 , 25, 26)
        self.connect(self.B4, QtCore.SIGNAL('clicked()'), self.up)

        self.i = 0

    def up(self):
        self.port= self.port + 2

    def down(self):
        self.port= self.port - 2



    def paintEvent(self, event):

        self.input_port.setText(str(self.port))
        self.label2.setText("<b>" +self.parent.connected)

        if self.parent.connected<>"No connection":
            self.b1.setText("Disconnect")
            self.b1.setEnabled(False)
            self.B3.setEnabled(False)
            self.B4.setEnabled(False)

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()





class w_SessionInformation(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 170)
        self.parent = parent
        self.session = session

        self.label0 = QtGui.QLabel('<b>Session Information', self)
        self.label0.move(15, 5)

        self.label1 = QtGui.QLabel('Session Number: ' + str(session.number) + "                                         ", self)
        self.label1.move(10, 30)
        self.label2 = QtGui.QLabel('Session Patient: '+ str(session.patientName)+ "                                         ", self)
        self.label2.move(10, 50)
        self.label3 = QtGui.QLabel('Therapy Type: '+ str(session.therapy)+ "                                         ", self)
        self.label3.move(10, 70)
        self.label4 = QtGui.QLabel('Session Time: '+ session.time_sting+ "                                         ", self)
        self.label4.move(10, 90)
        self.label5 = QtGui.QLabel('Session lengt: '+ session.time_sting_total + "                                  ", self)
        self.label5.move(10, 110)

        self.B_edit_number = QtGui.QPushButton('...', self)
        self.connect(self.B_edit_number, QtCore.SIGNAL('clicked()'), self.session.setTotaltimeUp)

        self.B_edit_name = QtGui.QPushButton('...', self)
        self.connect(self.B_edit_name, QtCore.SIGNAL('clicked()'), self.session.setTotaltimeUp)

        self.B_edit_type = QtGui.QPushButton('...', self)
        self.connect(self.B_edit_type, QtCore.SIGNAL('clicked()'), self.session.setTotaltimeUp)

        self.B_timeplus = QtGui.QPushButton('+5', self)
        self.B_timeplus.setGeometry(100, 135, 40, 26)
        self.connect(self.B_timeplus, QtCore.SIGNAL('clicked()'), self.setTotaltimeUp)

        self.B_timemin = QtGui.QPushButton('-5', self)
        self.B_timemin.setGeometry(150, 135, 40, 26)
        self.connect(self.B_timemin, QtCore.SIGNAL('clicked()'), self.setTotaltimeDown)

        self.B_start = QtGui.QPushButton('Start session', self)
        self.B_start.setGeometry(30, 135, 140, 26)
        self.connect(self.B_start, QtCore.SIGNAL('clicked()'), self.start)


    def setTotaltimeUp(self):
        self.session.setTotaltimeUp()

    def setTotaltimeDown(self):
        self.session.setTotaltimeDown()


    def start(self):     

        if  self.session.status=="Pauze":
            self.session.status="Started"
            time3 = time.strftime('%H:%M:%S')
            self.session.log=self.session.log+ "\n---- Start session, Time: " + time3 +" ----\n\n"
            self.parent.commandOut("START+++")



        elif  self.session.status=="Started":
            self.session.session_time_total =  self.session.session_time
            self.session.sessionEnd()
            self.parent.commandOut("END+++")

        elif  self.session.status=="Ended":
            self.parent.quitSession()

    def paintEvent(self, event):

        self.label1.setText('Session Number: ' + str(self.session.number))
        self.label2.setText('Session Patient: '+ self.session.patientName)
        self.label3.setText('Therapy Type: '+ self.session.therapy)
        self.label4.setText('Session Time: '+ self.session.time_sting)
        self.label5.setText('Session Lengt: '+ self.session.time_sting_total)



        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

        if self.session.status=="Pauze":

            self.B_edit_number.setGeometry(160,27,30,20)
            self.B_edit_name.setGeometry(160,47,30,20)
            self.B_edit_type.setGeometry(160,67,30,20)

            self.B_timeplus.setGeometry(160,107,30,20)
            self.B_timemin.setGeometry(126,107,30,20)
            self.B_start.setText("Start session")


        if self.session.status=="Started":

            self.B_edit_number.setGeometry(160,-107,30,20)
            self.B_edit_name.setGeometry(160,-107,30,20)
            self.B_edit_type.setGeometry(160,-107,30,20)

            self.B_timeplus.setGeometry(-100,0,10,10)
            self.B_timemin.setGeometry(-100,0,10,10)
            self.B_start.setText("End session")

        if self.session.status=="Ended":
            self.B_start.setText("Save and Quit") 


        if self.parent.simMode == True:
            self.B_start.setText("Waiting for Server")
            self.B_start.setEnabled(False)
            self.B_timeplus.setEnabled(False)
            self.B_timemin.setEnabled(False)
            self.B_edit_number.setEnabled(False)



class w_SessionTimeline(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(500, 230)
        size = self.size()
        w = size.width()
        h = size.height()

        self.parent = parent
        self.session = session

        self.scale = 1 # scale

        #addsesion
        self.b1 = QtGui.QPushButton('Add VR-Senario', self)
        self.b1.setEnabled(False)
        self.b1.setGeometry(5, 145, 140, 32)
        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.session.update)

        #sud label
        self.label1 = QtGui.QLabel(str(session.sud)+"    ", self)
        self.label1.move(10, 10)
        serifFont =QtGui.QFont("Verdana", 25)
        self.label1.setFont(serifFont)
        self.label1.resize(200,100)

        #time label
        self.label_time = QtGui.QLabel("  0:00:00", self)

        self.grid = QtGui.QImage()
        self.lastFlag = -100
        self.up = 0

    def paintEvent(self, event):

        #dimentioning
        size = self.size()
        w = size.width()
        h = size.height()
        i=0
        space= w-160.0
        tst = self.session.session_time_total

        step=(space/tst)
        self.scale = step
        rr = (self.scale*self.session.i)-self.scale+1

        #paint All
        paint = QtGui.QPainter()
        paint.begin(self)

        self.grid = QtGui.QImage()
        self.grid.load("res/bar.jpg")
        target = QtCore.QRectF(0, 20, w-1, 99)

        paint.drawImage(target,self.grid)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 20, w-1, 99)


        paint.setPen(QtGui.QColor(220, 220, 220))
        #paint.drawLine(1, 120-(self.session.sudMax*10), rr, 120-(self.session.sudMax*10))
        #paint.drawLine(1, 120-(self.session.sudMin*10), rr, 120-(self.session.sudMin*10))

        pen = QtGui.QPen(QtCore.Qt.black, 2, QtCore.Qt.SolidLine)
        paint.setPen(pen)

        for i in range(self.session.i-1):
            t = 10*self.session.history[i]
            tt = 10*self.session.history[i+1]
            paint.drawLine(i*self.scale, 120-t, i*self.scale+self.scale, 120-tt)

        paint.setPen(QtGui.QColor(255, 255, 255))
        paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 120, w-1, 10)

        j = 0
        self.num = [0.2, 0.4, 0.6, 0.8, 1.0]
        step=int(space/5)
        pen = QtGui.QPen(QtCore.Qt.black, 2, QtCore.Qt.SolidLine)
        paint.setPen(pen)

        for i in range(step, 6*step, step):
            paint.drawLine(i, 120, i, 124)
            metrics = paint.fontMetrics()
            tempst = self.session.Give_time_sting(self.session.session_time_total,self.num[j])
            fw = metrics.width(tempst)
            paint.drawText(i-fw/2, 136, tempst)
            j = j + 1

        paint.setBrush(QtGui.QColor(192, 192, 255))
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 139, rr-3, 40)


        #flag
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 218, w-1, 2)

        #self.ttt = QtGui.QPixmap("res/Patient_view.jpg")
        #self.buffer = QPixmap()
        #bitBlt(self, 0, 0, temp)
        #paint.drawImage(0,0, self.ttt)

        self.lastFlag = -12

        for i in range(len(self.session.flagArray)):
          flag = self.session.flagArray[i]
          tt = flag.time
          tt=int(tt*self.scale)
          ttt=tt
          self.up = tt

          if (tt - self.lastFlag )<22:
            tt = self.lastFlag + 22
            self.lastFlag = tt

          #else:
          #  self.lastFlag = tt
          #if i ==0:
          #  self.up=0

          #self.lastFlag = tt
          else:
            self.lastFlag = tt


          paint.drawLine(ttt,216, tt, 204)

          self.grid = QtGui.QImage()
          self.grid.load(flag.update())
          target = QtCore.QRectF(tt-10,185, 20, 20)
          paint.drawImage(target,self.grid)


          self.grid = QtGui.QImage()
          self.grid.load("res/bol.png")
          target = QtCore.QRectF(ttt-3,216, 7, 7)
          paint.drawImage(target,self.grid)

          #self.grid.load("res/flag.png")


        #bar
        pen = QtGui.QPen(QtCore.Qt.red, 2, QtCore.Qt.SolidLine)
        paint.setPen(pen)
        paint.drawLine(rr, 17, rr, 225)



        paint.end()

        #adjust labels and buttons
        st_s=str(round(self.session.sud2,1))
        if len(st_s)==1:
         st_s = st_s + ".0"
        self.label1.setText("<font color=black size=100><b>"+ st_s +"</b>")
        self.label1.move(5+rr, 16)

        self.label_time.setText(self.session.time_sting)
        self.label_time.move(rr-19, 2)

        self.b1.setGeometry(5+rr, 145, 130, 32)



class w_Score(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 120)
        self.parent = parent
        self.session = session

        self.label0 = QtGui.QLabel('<b>Simulation Score', self)
        self.label0.move(15, 5)
        self.label1 = QtGui.QLabel('                                                                   ' + str(session.number), self)
        self.label1.move(10, 30)
        self.label2 = QtGui.QLabel('                                                                   '+ str(session.patientName), self)
        self.label2.move(10, 50)
        self.label3 = QtGui.QLabel('                                                                   ', self)
        self.label3.move(10, 70)
        self.label4 = QtGui.QLabel('                                                                   '+ session.time_sting, self)
        self.label4.move(10, 90)

    def paintEvent(self, event):

        avg_score= "Error"
        if self.session.session_time>0:
          avg_score = self.session.score*1.00/self.session.session_time*1.00
          avg_score = round(avg_score,3)
          avg_score = "%3.3f" % avg_score

        self.label1.setText('Goal Min: ' + str(self.session.sudMax) + "   " + str(len(self.session.adjustArray)))
        self.label2.setText('Goal Max: '+ str(self.session.sudMin))
        self.label3.setText('State: ' + self.session.state  ) #'Low(-1) good(+1) High (-1) Ignoring(-2)'
        self.label4.setText('Score: '+ str(self.session.score) + "    Avg: " + avg_score)

        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()


class w_PatientTalk(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(400, 40)
        self.parent = parent
        self.session = session

        self.label0 = QtGui.QLabel('<b>Patient Talk:', self)
        self.label0.move(12, 13)
        self.label1 = QtGui.QLabel(' ' + str(session.number), self)
        self.label1.resize(600, 50)
        self.label1.move(94, -6)
        serifFont =QtGui.QFont("Verdana", 16)
        self.label1.setFont(serifFont)

    def paintEvent(self, event):

        self.label1.setText("<b>"+self.session.patientTalk)

        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()




#--------------------- Control -----------------------


class w_NoteControl(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 250)
        self.parent = parent
        self.session = session

        self.label1 = QtGui.QLabel('<b>Notes and Flages', self)
        self.label1.move(15, 5)

        self.b1_timer=0

        self.textEdit = QtGui.QTextEdit("",self)
        self.textEdit.move(10, 212)
        self.textEdit.resize(135, 20)
        #self.textEdit.setReadOnly(True)

        self.b1 = QtGui.QPushButton('"Patient has a question"', self)
        self.b1.setGeometry(10, 25, 180, 26)

        self.b2 = QtGui.QPushButton('"Patient has no fear"', self)
        self.b2.setGeometry(10, 55, 180, 26)

        self.b3 = QtGui.QPushButton('"Patient is frightened"', self)
        self.b3.setGeometry(10, 85, 180, 26)

        self.b4 = QtGui.QPushButton('"Patient has a panic attack"', self)
        self.b4.setGeometry(10, 115, 180, 26)

        self.b5 = QtGui.QPushButton('"Patient is okay again"', self)
        self.b5.setGeometry(10, 145, 180, 26)

        self.b6 = QtGui.QPushButton('', self)
        self.b6.setGeometry(10, 175, 180, 26)

        self.b7 = QtGui.QPushButton('Add', self)
        self.b7.setGeometry(150, 210, 40, 24)

        self.setConnections()

    def setConnections(self):

        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",1,    0,1,"Flag",1,"",0,""))
        self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",2,    0,1,"Flag",2,"",0,""))
        self.connect(self.b3, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",3,    0,1,"Flag",3,"",0,""))
        self.connect(self.b4, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",4,    0,1,"Flag",4,"",0,""))
        self.connect(self.b5, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",5,    0,1,"Flag",5,"",0,""))
        self.connect(self.b6, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",6,    0,1,"",1,"",0,""))
        self.connect(self.b7, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("F",7,    0,1,"",1,"",0,""))


    def paintEvent(self, event):


        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()


class w_SenarioControl(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 250)
        self.parent = parent
        self.session = session

        self.label1 = QtGui.QLabel('<b>VR-Senario Control', self)
        self.label1.move(15, 5)
        self.label2 = QtGui.QLabel('                         ', self)
        self.label2.move(150, 5)

        self.b1 = QtGui.QPushButton('Easier scenario', self)
        self.b1.setGeometry(10, 25, 180, 26)
        self.b2 = QtGui.QPushButton('Harder scenario', self)
        self.b2.setGeometry(10, 55, 180, 26)
        self.b3 = QtGui.QPushButton('Turbulence', self)
        self.b3.setGeometry(10, 85, 180, 26)
        self.b4 = QtGui.QPushButton('Thunder', self)
        self.b4.setGeometry(10, 115, 180, 26)
        self.b5 = QtGui.QPushButton('Redo Take off', self)
        self.b5.setGeometry(10, 145, 180, 26)
        self.b6 = QtGui.QPushButton('Redo landing', self)
        self.b6.setGeometry(10, 175, 180, 26)
        self.b7 = QtGui.QPushButton('', self)
        self.b7.setGeometry(10, 205, 180, 26)

        self.setConnections()

    def setConnections(self):

        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("W",1,     -3,30, "",1,"",10,"scenario"))
        self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("W",2,     3,30,"",1,"",10,"scenario"))
        self.connect(self.b3, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WV",1,     1,10,"",1,"",10,"scenario"))
        self.connect(self.b4, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WV",2,     1,10,"",1,"",10,"scenario"))
        self.connect(self.b5, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WV",3,     0,1,"",1,"",20,"scenario"))
        self.connect(self.b6, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WV",4,     0,1,"",2,"",20,"scenario"))
        self.connect(self.b7, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("",5,     0,10,"",1,"",10,"scenario"))

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

        if (self.session.Lock_scenario>0):
            self.label2.setText("Wait: " +str(int(self.session.Lock_scenario)))
            self.b1.setEnabled(False)
            self.b2.setEnabled(False)
            self.b3.setEnabled(False)
            self.b4.setEnabled(False)
            self.b5.setEnabled(False)
            self.b6.setEnabled(False)
            self.b7.setEnabled(False)
        else:
            self.label2.setText("")
            self.b1.setEnabled(True)
            self.b2.setEnabled(True)
            self.b3.setEnabled(True)
            self.b4.setEnabled(True)
            self.b5.setEnabled(True)
            self.b6.setEnabled(True)
            self.b7.setEnabled(True)  

class w_SenarioControlSocial(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 250)
        self.parent = parent
        self.session = session

        self.label1 = QtGui.QLabel('<b>VR-Senario Control', self)
        self.label1.move(15, 5)
        self.label2 = QtGui.QLabel('                         ', self)
        self.label2.move(150, 5)

        self.b1 = QtGui.QPushButton('Easier scenario', self)
        self.b1.setGeometry(10, 25, 180, 26)
        self.b2 = QtGui.QPushButton('Harder scenario', self)
        self.b2.setGeometry(10, 55, 180, 26)
        self.b3 = QtGui.QPushButton('Set new scenario', self)
        self.b3.setGeometry(10, 85, 180, 26)
        self.b4 = QtGui.QPushButton('Set Dialog subject: Dogs', self)
        self.b4.setGeometry(10, 115, 180, 26)
        self.b5 = QtGui.QPushButton('Set Dialog subject: Girls', self)
        self.b5.setGeometry(10, 145, 180, 26)
        self.b6 = QtGui.QPushButton('Set Dialog subject: Computer', self)
        self.b6.setGeometry(10, 175, 180, 26)
        self.b7 = QtGui.QPushButton('Set Dialog subject: Rodents', self)
        self.b7.setGeometry(10, 205, 180, 26)

        self.setConnections()

    def setConnections(self):

        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("W",1,     -3,30, "",1,"",10,"scenario"))
        self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("W",2,      3,30,"",1,"",10,"scenario"))
        self.connect(self.b3, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WS",1,     0,1,    "",1,"",15,"scenario"))
        self.connect(self.b4, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WS",2,     0,1,    "",1,"",10,"scenario"))
        self.connect(self.b5, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WS",3,     0,1,"",1,"",10,"scenario"))
        self.connect(self.b6, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WS",4,     0,1,"",2,"",10,"scenario"))
        self.connect(self.b7, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("WS",5,     0,1,"",1,"",10,"scenario"))

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

        if (self.session.Lock_scenario>0):
            self.label2.setText("Wait: " +str(int(self.session.Lock_scenario)))
            self.b1.setEnabled(False)
            self.b2.setEnabled(False)
            self.b3.setEnabled(False)
            self.b4.setEnabled(False)
            self.b5.setEnabled(False)
            self.b6.setEnabled(False)
            self.b7.setEnabled(False)
        else:
            self.label2.setText("")
            self.b1.setEnabled(True)
            self.b2.setEnabled(True)
            self.b3.setEnabled(True)
            self.b4.setEnabled(True)
            self.b5.setEnabled(True)
            self.b6.setEnabled(True)
            self.b7.setEnabled(True)


class w_PatientControl(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(200, 250)
        self.parent = parent
        self.session = session

        self.label1 = QtGui.QLabel('<b>Patient Control', self)
        self.label1.move(15, 5)
        self.label2 = QtGui.QLabel('                         ', self)
        self.label2.move(150, 5)

        #self.session
        self.b1 = QtGui.QPushButton('Attend to patient', self)
        self.b1.setGeometry(10, 25, 180, 26)
        self.b2 = QtGui.QPushButton('Ask sud score', self)
        self.b2.setGeometry(10, 55, 180, 26)
        self.b3 = QtGui.QPushButton('Tell the patient we will continue', self)
        self.b3.setGeometry(10, 85, 180, 26)
        self.b4 = QtGui.QPushButton('Explain scenario', self)
        self.b4.setGeometry(10, 115, 180, 26)
        self.b5 = QtGui.QPushButton('Explain fear', self)
        self.b5.setGeometry(10, 145, 180, 26)
        self.b6 = QtGui.QPushButton('Ask if the patient is okay', self)
        self.b6.setGeometry(10, 175, 180, 26)
        self.b7 = QtGui.QPushButton('Calm patient down', self)
        self.b7.setGeometry(10, 205, 180, 26)

        self.setConnections()

    def setConnections(self):

        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",1,    0,1,   "",1,     "",10,"patient"))
        self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",2,    0,1,     "Flag",6,   "",5,"patient"))
        self.connect(self.b3, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",3,    0,1,     "",1,       "",5,"patient"))
        self.connect(self.b4, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",4,    0,1,    "",1,       "" ,20,"patient"))
        self.connect(self.b5, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",5,    0,1,   "",1,       "",20,"patient"))
        self.connect(self.b6, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",6,    0,1,   "",1,       "",5,"patient"))
        self.connect(self.b7, QtCore.SIGNAL('clicked()'), self.session.AdjustSimulation("P",7,    -2,10,   "",1,       "", 15, "patient"))

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()


        if (self.session.Lock_talkToPatient>0):
            self.label2.setText("Wait: " +str(int(self.session.Lock_talkToPatient)))
            self.b1.setEnabled(False)
            self.b2.setEnabled(False)
            self.b3.setEnabled(False)
            self.b4.setEnabled(False)
            self.b5.setEnabled(False)
            self.b6.setEnabled(False)
            self.b7.setEnabled(False)
        else:
            self.label2.setText("")
            self.b1.setEnabled(True)
            self.b2.setEnabled(True)
            self.b3.setEnabled(True)
            self.b4.setEnabled(True)
            self.b5.setEnabled(True)
            self.b6.setEnabled(True)
            self.b7.setEnabled(True)


class w_AlertControl(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(140, 250)
        self.parent = parent
        self.session = session

        self.label1 = QtGui.QLabel('<b>Alert Control', self)
        self.label1.move(15, 5)
        self.label2 = QtGui.QLabel('                         ', self)
        self.label2.move(150, 5)

        self.b1 = QtGui.QPushButton('Stop\nAssisting\nPartient', self)
        self.b1.setGeometry(10, 30, 120, 66)
        self.b2 = QtGui.QPushButton('Call for\nRemote\nAssistance', self)

        serifFont =QtGui.QFont("Arial",  9)
        serifFont.setBold(True)
        self.b2.setFont(serifFont)

        self.b2.setGeometry(20, 145, 100, 76)


        self.setConnections()

    def setConnections(self):

        self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.parent.stopAssit)
        self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.parent.localAssit)

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()
        cw = self.parent.cw

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)

        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 0, 0))
        paint.drawRect(10, 135, 120, 96)
        paint.end()



        if (self.session.Lock_talkToPatient>0) and self.session.cancel==True:
            #self.label2.setText("Wait: " +str(int(self.session.Lock_scenario)))
            self.b1.setEnabled(True)
            self.b2.setEnabled(True)

        else:
            self.label2.setText("")
            self.b1.setEnabled(False)
            self.b2.setEnabled(True)



#--------------------- Hidden -----------------------



class w_notes(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)

        size = self.size()
        w = size.width()
        h = size.height()
        self.parent = parent
        self.session = session

        self.label0 = QtGui.QLabel("<b>Log File", self)
        self.label0.move(15, 5)

        #self.textEdit = QtGui.QTextEdit()
        self.textEdit = QtGui.QTextEdit("   ",self)
        self.textEdit.move(10, 23)

        self.textEdit.setReadOnly(True)

        self.old_text = "  "

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()


        self.textEdit.resize(w-21,h-32)


        if self.old_text<>self.session.log:

            self.textEdit.setText(self.session.log)

            self.old_text = self.session.log

            bar =self.textEdit.verticalScrollBar()
            maxx = bar.maximum()
            bar.setValue(maxx)



        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()



class w_view(QtGui.QLabel):
    def __init__(self, parent, image, name):


        self.session = ""
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.label0 = QtGui.QLabel("<b><center>" +name, self)
        self.label0.move(0, 2)
        self.label0.resize(w,20)

        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(20, 25)
        self.label.setPixmap(self.image)

        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)




    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()
    
        self.label0.resize(w,20)
        self.label.resize(w-42,h-42)

        self.label.setPixmap(self.image)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_view2(QtGui.QLabel):
    def __init__(self, parent, image, name):


        self.session = ""
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(0, 0)
        self.label.setPixmap(self.image)

        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)




    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        self.label.resize(w,h)
        self.label.setPixmap(self.image)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()



######basic widgetes

class w_white(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(1, 30)
        self.parent = parent

    def paintEvent(self, event): 

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(255, 255, 255))
        paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 0, w, h)
        paint.end()


class w_black(QtGui.QLabel):
    def __init__(self, parent):
        QtGui.QLabel.__init__(self, parent)
        self.setMinimumSize(1, 30)
        self.parent = parent

    def paintEvent(self, event): 

        size = self.size()
        w = size.width()
        h = size.height()

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(0, 0, 0))
        paint.drawRect(0, 0, w, h)
        paint.end()


class w_Lock(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()

        self.image= QtGui.QPixmap("res/black.png")
        self.parent = parent
        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(0, 0)
        self.label.setPixmap(self.image)
        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)

    def paintEvent(self, event):
        size = self.size()
        w = size.width()
        h = size.height()
        self.label.resize(w,h)




class w_Warning(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()



        self.image= QtGui.QPixmap("res/black.png")

        self.parent = parent

        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(0, 0)
        self.label.setPixmap(self.image)

        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)

        self.w_w= w_WarningWindow(self,session)
        self.w_w.move


    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        #self.label.resize(w,h)

        #500 - 300
        tw = (w/2) - 300
        th = (h/2) - 200

        self.w_w.move(tw,th)
        self.label.resize(w,h)

        #paint = QtGui.QPainter()
        #paint.begin(self)
        #paint.setPen(QtGui.QColor(0, 0, 0))
        #paint.setBrush(QtGui.QColor(247, 247, 247))
        #paint.drawRect(tw, th, 600, 400)
        #paint.end()


class w_WarningWindow(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(600, 400)
        size = self.size()
        w = size.width()
        h = size.height()

        self.parent = parent
        self.session=session
        self.blink = 1

        self.sec = 101
        serifFont =QtGui.QFont("Verdana", 25)
        serifFont2 =QtGui.QFont("Verdana", 15)

        self.label0 = QtGui.QLabel('<font color=red size=100><b><center>Warning<b>', self)
        self.label0.move(0, 0)
        self.label0.resize(600,100)
        self.label0.setFont(serifFont)

        self.label1 = QtGui.QLabel('<b><center>Who: Patient ' +  self.session.patientLetter  + "  -  " + self.session.patientName , self)
        self.label1.move(0, 80)
        self.label1.resize(600,100)
        self.label1.setFont(serifFont2)

        self.label2 = QtGui.QLabel('<b><center>What happend: Anxiety score high threshold' , self)
        self.label2.move(0, 120)
        self.label2.resize(600,100)
        self.label2.setFont(serifFont2)

        self.label2 = QtGui.QLabel('<b><center>Auto Assit will take over in '+ str(self.sec)+ ' seconds' , self)
        self.label2.move(0, 220)
        self.label2.resize(600,100)
        self.label2.setFont(serifFont2)


        self.B1 = QtGui.QPushButton('Cancel Auto Assist', self)
        self.B1.setGeometry(200, 305 , 200, 50)
        self.connect(self.B1, QtCore.SIGNAL('clicked()'), self.cancel)

        serifFont3 =QtGui.QFont("Verdana", 10)
        self.B1.setFont(serifFont3)

    def cancel(self):
        pass
        self.parent.hide()
        self.sec = 101
        #self.parent.session.alarm=False

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        #self.label.resize(w,h)

        #500 - 300
        tw = (w/2) - 300
        th = (h/2) - 200

        self.blink = self.blink+1

        if self.blink < 40:
            self.label0.setText('<font color=#c90000 size=100><b><center>Warning<b>')

        if self.blink > 40:
            self.label0.setText('<font color=Black size=100><b><center>Warning<b>')

        if self.blink > 80:
            self.blink = 0

        self.label2.setText('<b><center>Auto Assit will take over in '+ str(self.sec)+ ' seconds')

        self.label1.setText('<b><center>Who: Patient ' +  self.session.patientLetter  + "  -  " + self.session.patientName)


        paint = QtGui.QPainter()
        paint.begin(self)
        pen = QtGui.QPen(QtCore.Qt.black, 7, QtCore.Qt.SolidLine)
        paint.setPen(pen)
        #paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_WorkloadWindow(QtGui.QLabel):
    def __init__(self, parent, session):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(760, 700)
        size = self.size()
        w = size.width()
        h = size.height()

        self.parent = parent
        self.session=session

        self.label = QtGui.QLabel("", self)
        self.label.move(25, 30)
        self.label.setPixmap(QtGui.QPixmap("res/scale.png"))
        #self.label.setScaledContents(True)
        #self.label.resize(386,646)


        serifFont =QtGui.QFont("Verdana", 15)
        serifFont2 =QtGui.QFont("Verdana", 10)

        self.label0 = QtGui.QLabel('<font size=5><b><center>Rating Scale Mental Effort <b>', self)
        self.label0.move(150, 40)
        self.label0.resize(600,100)
        self.label0.setFont(serifFont)

        self.label1 = QtGui.QLabel('<b>Please indicate by moving the slider <BR>how much effort it took for you to<br>complete the task you just finished.'  , self)
        self.label1.move(420, 220)
        self.label1.resize(600,100)
        self.label1.setFont(serifFont2)


        self.B1 = QtGui.QPushButton('Ok', self)
        self.B1.setGeometry(600, 390 , 100, 26)
        self.connect(self.B1, QtCore.SIGNAL('clicked()'), self.ok)


        self.slider = QtGui.QSlider(QtCore.Qt.Vertical, self)
        self.slider.move(86, 55)
        self.slider.resize(25, 612)

        self.label3 = QtGui.QLabel('<font size=5><b><center>Score (0-150):  '  , self)
        self.label3.move(430, 320)
        self.label3.setFont(serifFont)

        #self.label2.resize(600,100)

        #self.connect(self.slider,  QtCore.SIGNAL('valueChanged(int)'), self.label3 , QtCore.SLOT('setText(int)') )


        self.value = 0


    def ok(self):
        pass
        self.hide()
        self.parent.commandOut("WORKLOAD#"+ str( self.value) )


    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()


        temp = 10

        temp = self.slider.value()

        temp = int(temp * 1.52)
        self.label3.setText("<font size=5><b><center>" + str(temp))

        self.value = temp

        paint = QtGui.QPainter()
        paint.begin(self)
        pen = QtGui.QPen(QtCore.Qt.black, 7, QtCore.Qt.SolidLine)
        paint.setPen(pen)
        #paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 0, w-1, h-1)


        pen = QtGui.QPen(QtCore.Qt.black, 1, QtCore.Qt.SolidLine)
        paint.setPen(pen)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(400, 230, 320, 200)





        paint.end()



class w_Image(QtGui.QLabel):
    def __init__(self, parent, image):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(10, 10)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.scale = 1
        self.label = QtGui.QLabel("", self)
        self.label.move(1, 1)
        self.label.setPixmap(self.image)

        self.label.setScaledContents(True)
        self.label.resize(w-1,h-1)

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        self.label.resize(w-2,h-2)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        paint.setBrush(QtGui.QColor(247, 247, 247))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()

class w_Movie(QtGui.QLabel):
    def __init__(self, parent, image):
        QtGui.QLabel.__init__(self, parent)

        self.setMinimumSize(100, 100)
        size = self.size()
        w = size.width()
        h = size.height()
        self.image= image
        self.parent = parent

        self.scale = 1
        self.label = QtGui.QLabel("    ", self)
        self.label.move(0, 0)

        self.label.resize(w-1,h-1)

        self.mov = QtGui.QMovie("mov/globe.gif")
        self.mov.start()

        self.mov.setSpeed(800)

        self.label.setMovie(self.mov)


        #self.label.setScaledContents(True)
        #self.label.resize(w-1,h-1)

    def paintEvent(self, event):

        size = self.size()
        w = size.width()
        h = size.height()

        self.label.resize(w-1,h-1)

        #self.mov.jumpToNextFrame()
        #self.label.setMovie(self.mov)

        paint = QtGui.QPainter()
        paint.begin(self)
        paint.setPen(QtGui.QColor(0, 0, 0))
        #paint.setBrush(QtGui.QColor(255, 255, 255))
        paint.drawRect(0, 0, w-1, h-1)
        paint.end()







