#!/usr/bin/python

# mainwindow.py 

import sys
from PyQt4 import QtGui, QtCore
import random
import time


from MainWidgets import *

from SessionControl import *
from SessionStore import *
from SimulationCreator import *


from MyConnection import *


class MainWindow(QtGui.QMainWindow):
    def __init__(self):
        QtGui.QMainWindow.__init__(self)

        #window
        self.resize(240, 372)
        self.move(30, 30)
        self.setMinimumSize(1050, 812)
        self.setMaximumSize(1050, 812)
        self.setWindowTitle('Simulation Control')
        self.setAutoFillBackground ( True )
        self.resize =False
        self.startin = -1

        #session control
        self.sessionControl = SessionControl(self)
        self.simulationCreator = SimulationCreator()
        self.numberOfSessions = 0

        self.selectedSession = SessionStore(self, -1, "A","<none>", "", "<none>",-1)  #empty
        self.selectedSession.sud2 = 0.0
        self.selectedSessionI = 0
        self.ii = 0
        #Basic variables
        self.flag_pauze = False

        #clock
        self.time1 = time.clock()
        self.timeround = round(self.time1)
        self.speed = 1.0
        self.totaltimesec =0
        self.time_sting = "0:00:00"

        #frame update time
        self.timer = QtCore.QTimer()
        self.timer.start(10)
        self.connect(self.timer, QtCore.SIGNAL("timeout()"), self.Update)

        #networkconnection
        self.ConnectionsInArray = []
        self.ConnectionsOutArray = []
        self.log=""
        self.comm_out = ""
        self.comm_in = ""
        self.phase = 0
        self.skip=False


############### Screen ################

        #white back groung
        size = self.size()
        self.w = size.width()
        self.h = size.height()

        self.w_back = w_white(self)
        self.w_back.move(0, 55)
        #self.wid10.resize(w,h-55)
        self.w_back.resize(2000,2000)

        #widgets
        self.w_time = w_time(self)
        self.w_time.move(20, 70)
        #self.wid6.resize(0,0)

        self.w_sesions = w_WindowControl(self, self.sessionControl)
        self.w_sesions.move(20, 160)
        #self.wid4.resize(100,100)

        self.w_info = w_ControlInfo(self, self.sessionControl)
        self.w_info.move(440, 70)
        self.w_info.resize(590,280)

        self.w_tl = w_SessionTimeline2(self, self.selectedSession, 1)
        self.w_tl.move(20, 360)
        self.w_tl.resize(1010,230)
        #self.w_tl.mode =0

        self.w_conn = w_ConnectionControl(self)
        self.w_conn.move(230, 70)
        #self.w_conn.resize(710,20)

        self.w_score = w_Score(self, self.selectedSession)
        self.w_score.move(20, 600)
        self.w_score.resize(1010,200)
        #self.w_tl.mode =0


### Menu Items
        exit = QtGui.QAction(QtGui.QIcon('icons/i_clear.png'), 'Exit', self)
        exit.setShortcut('escape')
        exit.setStatusTip('Exit application')
        self.connect(exit, QtCore.SIGNAL('triggered()'), self.exit)

        #time
        reset = QtGui.QAction(QtGui.QIcon('icons/i_reset.png'), 'Reset', self)
        reset.setShortcut('Ctrl+R')
        reset.setStatusTip('Reset Time')
        self.connect(reset, QtCore.SIGNAL('triggered()'), self.ResetTimer)

        play = QtGui.QAction(QtGui.QIcon('icons/i_go.png'), 'Play', self)
        play.setShortcut('Ctrl+P')
        play.setStatusTip('Play')
        self.connect(play, QtCore.SIGNAL('triggered()'), self.setPlay)

        pauze = QtGui.QAction(QtGui.QIcon('icons/i_pauze.png'), 'Pauze', self)
        pauze.setShortcut('Ctrl+L')
        pauze.setStatusTip('Pauze')
        self.connect(pauze, QtCore.SIGNAL('triggered()'), self.setPauze)

        slow = QtGui.QAction(QtGui.QIcon('icons/i_slow.png'), 'Time /2', self)
        slow.setShortcut('+')
        slow.setStatusTip('Time /2')
        self.connect(slow, QtCore.SIGNAL('triggered()'), self.setSlow)

        fast = QtGui.QAction(QtGui.QIcon('icons/i_fast.png'), 'Time x2', self)
        fast.setShortcut('-')
        fast.setStatusTip('Time x2')
        self.connect(fast, QtCore.SIGNAL('triggered()'), self.setFast)

        self.statusBar()

        menubar = self.menuBar()
        file = menubar.addMenu('&File')
        file.addAction(exit)

        file = menubar.addMenu('&Timer')
        file.addAction(reset)
        file.addAction(play)
        file.addAction(pauze)
        file.addAction(slow)
        file.addAction(fast)

        toolbar = self.addToolBar('Exit')
        toolbar.addAction(exit)

        toolbar_time = self.addToolBar('Timer')
        toolbar_time.addAction(reset)
        toolbar_time.addAction(play)
        toolbar_time.addAction(pauze)
        toolbar_time.addAction(slow)
        toolbar_time.addAction(fast)

        #self.AddSession()

    def keyPressEvent(self, event):

        key = event.key()
        if key == QtCore.Qt.Key_F1:

            if self.w_tl.mode== 1:
                self.w_tl.mode =0
            else:
                self.w_tl.mode =1
            self.w_tl.repaint()

        if key == QtCore.Qt.Key_F2:
            self.askWorkload()
            #self.skip=True


        if key == QtCore.Qt.Key_F3:


            if self.sessionControl.sessionArray[0].session_time< 5*60:
                self.commandOut("SETTIME#"+str(5*60),-1)
            elif self.sessionControl.sessionArray[0].session_time< 10*60:
                self.commandOut("SETTIME#"+str(10*60),-1)
            elif self.sessionControl.sessionArray[0].session_time< 15*60:
                self.commandOut("SETTIME#"+str(15*60),-1)


            self.sessionControl.level = 0
            self.sessionControl.resetScore()


#Time manupulation

    def ResetTimer(self):
        self.totaltimesec=0
        self.sessionControl.reset()

    def setPauze(self):
        self.flag_pauze = True
        self.speed = 0.0
        self.speedChange()

    def setPlay(self):
        self.flag_pauze = False
        self.speed = 1.0
        self.speedChange()

    def setFast(self):
        self.speed=self.speed*2
        if self.speed>32.0:
          self.speed = 32.0
        self.speedChange()

    def setSlow(self):
        self.speed=self.speed/2
        self.speedChange()

    def speedChange(self):
        self.sessionControl.speed  = self.speed
        self.commandOut("SPEED#"+str(self.speed),-1)

    def exit(self):
        self.close()


#Update

    #update Faste every 10 milisecond
    def Update(self):

        #internal clock
        self.temptime = self.timeround
        self.time1 = time.clock()
        self.timeround = round(self.time1*self.speed)

        if self.flag_pauze == False:
            #sec
            if self.temptime<> self.timeround:
                self.SecUpdate()

        #update selected session
        temp = self.w_info.ListView.currentRow()
        if len(self.sessionControl.sessionArray) == 1:
            temp = 0
        if len(self.sessionControl.sessionArray) > 1 and self.w_info.ListView.currentRow() == -1:
            temp = 0
        if temp>-1:
            self.selectedSession = self.sessionControl.sessionArray[temp]
        if self.ii<>temp:
          self.w_tl.session = self.selectedSession
          self.w_score.session  = self.selectedSession
          self.w_score.repaint()
          self.w_tl.repaint()
          self.ii = temp


        #repaint
        self.w_time.repaint()

        #Check incommming Data
        for i in range(len(self.ConnectionsInArray)):
            self.comm_in = self.ConnectionsInArray[i]

            if (self.comm_in.connected==True):
                if self.comm_in.Output <> "":
                    self.commandIn(self.comm_in.Output, i)
                    self.comm_in.Output = ""

        #Initalize Connecion
        for i in range(len(self.ConnectionsOutArray)):
            self.comm_out = self.ConnectionsOutArray[i]

            if (self.comm_out.connected==True):

                self.sessionControl.firstConnection(i)

                if  self.comm_out.initialized == False:
                  self.commandOut("SPEED#"+str(self.speed),i)
                  self.comm_out.initialized = True

#every simulated second
    def SecUpdate(self):
        self.totaltimesec=self.totaltimesec+1
        self.time_sting = self.sessionControl.Give_time_sting(self.totaltimesec,1)
        
        self.sessionControl.update()
        self.w_info.repaint()
        self.w_conn.repaint()
        self.w_score.repaint()
        #self.tl.repaint()

        #print str(self.startin)

        if self.startin > -1:
            self.startin = self.startin -1
            if self.startin == 0:

              for i in range(len(self.sessionControl.sessionArray)):
                    self.sessionControl.sessionArray[i].score = 0

              self.speed = 1.0
              self.speedChange()
              self.startin = -1


#create session
    def ceateSimulation(self):
        self.simulationCreator.createSessions(self.sessionControl)

    def ceateSimulationAssist(self):
        self.simulationCreator.createAssistSessions(self.sessionControl)

    def ceateTestSimulation(self):
        self.simulationCreator.createTestSessions(self.sessionControl)

    def ceateTestSimulationAssist(self):
        self.simulationCreator.createAssistTestSessions(self.sessionControl)

#Start a new session
    def StartNewSession(self, ii):

        i = len(self.sessionControl.sessionArray)

        session= SessionStore(self.sessionControl ,i,"A","<None>",1, "<none>", ii)
        self.sessionIndex = self.sessionControl.addNewSession(session)

#Start a new session
    def reset(self):
        self.sessionControl.reset()
        self.phase = 0
        self.selectedSession = SessionStore(self, -1, "A","<none>", "", "<none>",-1)  #empty
        self.selectedSession.sud2 = 0.0
        self.selectedSessionI = 0
        self.ii = 0

        self.commandOut("RESET",-1)


    def askWorkload(self):

        self.setPauze()
        i = len(self.ConnectionsOutArray)

        if i==1:
            self.commandOut("WORK",0)
        else:
            self.commandOut("WORK",1)




    def saveData(self):

        nr = self.w_score.inputnr.displayText()

        rand = random.randint(1,10000)
        random.jumpahead(1)
        filename = nr+ "-" +  str(rand) + ".txt"

        FILE = open("data/" + filename,"w")

        bestand = nr + ";" + self.sessionControl.data


        FILE.writelines(bestand)

        FILE.close()




#---------------------connecetions--------------------

    def addConnection(self):

        send = self.w_conn.checkBox.checkState()
        if send==0:
            send = False
        else:
            send = True

        port = self.w_conn.input_port.displayText()
        port=int(port)
        host = self.w_conn.input_host.displayText()

        self.ConnectionsOutArray.append(MyConnection(send, host,port))

        if send==False:
            send = True
        else:
            send = False

        self.ConnectionsInArray.append(MyConnection(send, host,port+1))

# command IN
    def commandIn(self,text, i):

        ses= SessionStore(self, -1, "A","<none>", "", "<none>",-1)
        sesi = -10

        for j in range(len(self.sessionControl.sessionArray)):
            if (self.sessionControl.sessionArray[j].status <> "Ended") and (self.sessionControl.sessionArray[j].connectionIndex ==i):
                  ses = self.sessionControl.sessionArray[j]
                  sesi = j

        print "S - In: " + text

        if text == "NEW+++":
            self.StartNewSession(i)
            self.w_info.repaint()

        if text == "START+++":
            ses.status="Started"
            #time3 = time.strftime('%H:%M:%S')
            #ses.log=self.session.log+ "\n---- Start session, Time: " + time3 +" ----\n\n"
            if sesi == self.ii:
                self.w_tl.repaint()

        if text == "END+++":
            ses.session_time_total =  ses.session_time
            ses.sessionEnd()
            if sesi == self.ii:
                self.w_tl.repaint()

        if text == "SETLENGTH":
            ses.setTotaltimeDown()
            if sesi == self.ii:
                self.w_tl.repaint()

        text2= text.split('#')
        if (len(text2)) == 2:

          if text2[0] =="WORKLOAD":
                try:
                    ret1 = int(text2[1])
                except ValueError:
                    ret1 = -1
                if ret1>-1:
                    ses.workload = ret1
                    self.w_score.repaint()

                    self.sessionControl.level = 0
                    self.sessionControl.resetScore()
                    self.flag_pauze = False

                    if self.phase == 0:
                        self.commandOut("SETTIME#"+str(5*60),-1)
                        self.phase = self.phase + 1
                    elif self.phase == 1:
                        self.commandOut("SETTIME#"+str(10*60),-1)
                        self.phase = self.phase + 1
                    elif self.phase == 2:
                        self.commandOut("SETTIME#"+str(15*60),-1)
                        self.phase = self.phase + 1

                    self.w_score.repaint()

                    self.startin = 6
                    self.speed = 1.0


          if text2[0] =="SETLENGTH":
                try:
                    ret1 = int(text2[1])
                except ValueError:
                    ret1 = -1
                if ret1>-1:
                    ses.session_time_total = ret1
                    if sesi == self.ii:
                        self.w_tl.repaint()

          if text2[0] =="LOCKP":
              try:
                  ret1 = float(text2[1])
              except ValueError:
                  ret1 = -1
              if ret1>-1:

                  for j in range(len(self.sessionControl.sessionArray)):
                      self.commandOut("LOCKP#"+str(ret1),j)


                  if ret1 == 0:
                      ses.RemoveLastEa()


        if (len(text2)) == 2:
          if text2[0] =="LOCKS":
              try:
                  ret1 = float(text2[1])
              except ValueError:
                  ret1 = -1
              if ret1>-1:

                  for j in range(len(self.sessionControl.sessionArray)):
                      self.commandOut("LOCKS#"+str(ret1),j)


        if (len(text2)) == 3:

          if text2[0] =="SUD":
              try:
                  ret = float(text2[1])

              except ValueError:
                  ret = -1
              try:
                  ret2 = int(text2[2])
              except ValueError:
                  ret2 = -1
              if ret>-1 and ret2>-1:

                    ses.sud = ret
                    ses.sud2 = ret
                    pp = ses.session_time
                    for j in range(ret2-pp):
                          ses.sud = ret
                          ses.sud2 = ret
                          ses.update()

                    if sesi == self.ii:
                        self.w_tl.repaint()

          if text2[0] =="EA":
              try:
                  ret1 = text2[1]
              except ValueError:
                  ret1 = -1
              try:
                  ret2 = int(text2[2])
              except ValueError:
                  ret2 = -1
              if ret1>-1 and ret2>-1:

                    if  ret1 =="A":
                        ses.autoCorrectEa()
                        #ses.error=ses.error-1
                    else:
                        ses.CheckEa(ret1, ret2)

                    self.w_score.repaint()

        if (len(text2)) == 4:

          if text2[0] =="FLAG":
              try:
                  ret1 = str(text2[1])
              except ValueError:
                  ret1 = -1
              try:
                  ret2 = int(text2[2])
              except ValueError:
                  ret2 = -1
              try:
                  ret3 = int(text2[3])
              except ValueError:
                  ret3 = -1
              if ret1>-1 and ret2>-1:

                    ses.setFlag(ret1,ret2,ret3)

                    if ret1 == "RA":
                        ses.RemoteAssist =  ses.RemoteAssist +1
                        ses.autoCorrectEa()


                    if sesi == self.ii:
                        self.w_tl.repaint()

# command Out
    def commandOut(self, text,i):        #if i=-1 send to all

        if i==-1:
            for i in range(len(self.ConnectionsOutArray)):
                self.conn = self.ConnectionsOutArray[i]
                print "S - Out: " + text
                self.conn.command = self.conn.command + "|" + text

        else:
            if (len(self.ConnectionsOutArray))>i:

              self.conn = self.ConnectionsOutArray[i]

              print "S - Out: " + text

              self.ConnectionsOutArray[i].sendCommand(text)




#Run Aplication
app = QtGui.QApplication(sys.argv)

main = MainWindow()
main.show()

sys.exit(app.exec_())

