import sys
from PyQt4 import QtGui, QtCore
import random

from SessionControl import *
from Session import *
from TherapistWidgets import *
from MyConnection import *

from TherapistSoundImageControl import *

class TherapistSessionWindow(QtGui.QMainWindow):
    def __init__(self):
        QtGui.QMainWindow.__init__(self)

        self.setMinimumSize(1002, 552)
        #window
        self.cw = 0
        self.resize(1002, 552)
        self.setWindowTitle('Patient')
        self.setAutoFillBackground ( True )

        self.noSession=True
        self.test = 0
        self.connected="No connection"

        #Add session
        self.session= Session(self,"_","None", "", "None")
        self.simMode = False

        #patient view window
        self.tpvw = TherapistPatientViewWindow(self.session)

        self.Assisting = -101


        #white back groung
        size = self.size()
        self.w = size.width()
        self.h = size.height()

        self.w_back = w_white(self)
        self.w_back.move(0, 0)
        self.w_back.resize(2000,2000)

        #varables:
        self.flag_fullscreen = False

        #connection
        self.log=""

        #time
        self.time1 = time.clock()
        self.timeround = round(self.time1)
        self.temptime2 = 0
        self.timeround2 = 0

        self.speed = 1.0
        self.totaltimesec =0
        self.time_sting = "0:00:00"
        self.countt = 0

        #frame update time
        self.timer = QtCore.QTimer()
        self.timer.start(10)
        self.connect(self.timer, QtCore.SIGNAL("timeout()"), self.Update)


        self.TSIC = TherapistSoundImageControl(self, self.session)



#---------widgets--------------------------------
        self.w_si = w_SessionInformation(self, self.session)
        self.w_si.move(10, 10)

        self.w_ss = w_SessionStart(self)
        self.w_ss.move(10, 10)

        self.w_conn= w_Connection(self)
        self.w_conn.move(10, 190)

        self.w_stl = w_SessionTimeline(self, self.session)
        self.w_stl.move(10, 30)
        self.w_stl.resize(960,100)

        #control
        self.w_nc = w_NoteControl(self, self.session)
        self.w_sc = w_SenarioControl(self, self.session)
        self.w_sc2 = w_SenarioControlSocial(self, self.session)
        self.w_sc2.hide()


        self.w_pc = w_PatientControl(self, self.session)

        self.w_ac = w_AlertControl(self, self.session)

        self.w_pt = w_PatientTalk(self, self.session)

        #Hidden
        self.w_notes = w_notes(self, self.session)
        self.w_assist = w_view(self, QtGui.QPixmap("res/leeg.jpg"), "Assist Setup")

        self.w_vwView = w_view(self, QtGui.QPixmap("res/ruis.jpg"), "VR View")
        #self.w_pView = w_view(self, QtGui.QPixmap("res/patient1.jpg"), "Patient View")




        #warning:
        self.w_warning = w_Warning(self, self.session)
        self.w_warning.move(0, 0)
        self.w_warning.resize(500,300)
        self.w_warning.hide()


        self.w_lock = w_Lock(self, self.session)
        self.w_lock.move(0, 0)
        self.w_lock.resize(500,300)
        self.w_lock.hide()  

        self.w_workload = w_WorkloadWindow(self, self.session)
        self.w_workload.move(0, 0)
        self.w_workload.resize(760, 700)
        self.w_workload.hide()




    def quitSession(self):
        self.noSession=True
        self.w_ss.show()

    def StartNewSession(self):

        self.commandOut("NEW+++")

        self.session = Session(self, "A","None",1, "None")
        self.session.patientTalk = "I am ready to start"

        self.w_si.session = self.session
        self.w_stl.session = self.session
        self.w_nc.session = self.session
        self.w_nc.setConnections()
        self.w_sc.session = self.session
        self.w_sc.setConnections()
        self.w_pc.session = self.session
        self.w_pc.setConnections()
        self.w_notes.session = self.session
        self.w_vwView.session = self.session
        #self.w_pView.session = self.session
        self.w_assist.session = self.session
        self.w_pt.session = self.session
        self.w_warning.w_w.session = self.session
        self.Update()

        self.noSession=False
        self.w_ss.close()
        #self.w_ss.show()   



#update every 10 mili second
    def Update(self):
        #time
        self.temptime = self.timeround
        self.time1 = time.clock()
        self.timeround = round(self.time1*self.speed)

        if self.temptime<> self.timeround:
            self.secUpdate()

        self.temptime2 = self.timeround2
        self.timeround2  = round(self.time1)

        if self.temptime2<> self.timeround2:
            self.countt=self.countt+1
            if self.countt ==2:
                  self.fiveSecUpdate()
                  self.countt = 0

        #repaint
        self.w_pc.repaint()
        self.w_sc.repaint()
        self.w_sc2.repaint()
        self.w_pt.repaint()
        self.w_ac.repaint()



        self.w_warning.w_w.repaint()

        #input
        if self.connected=="Looking":
            if (self.Conn_in.connected==True) and (self.Conn_out.connected==True):
                self.connected="Connected"

        if self.connected=="Connected": 

            if self.Conn_in.Output <> "":

                self.commandIn(self.Conn_in.Output)
                self.Conn_in.Output = ""


#update every senario second
    def secUpdate(self):

        self.session.update()

        self.w_si.repaint()
        self.w_stl.repaint()
        self.w_pc.update()
        self.w_pc.repaint()
        self.w_sc.repaint()
        self.w_nc.update()
        self.w_nc.repaint()

        self.w_conn.repaint()
        self.w_notes.repaint()


        #warning + assist
        if self.session.assist== True:

          #print str(self.w_warning.w_w.sec)


          if self.w_warning.w_w.sec<=100:
            self.w_warning.w_w.sec = self.w_warning.w_w.sec -1

          if self.w_warning.w_w.sec<1:
            self.w_warning.hide()
            self.w_warning.w_w.sec = 101
            self.session.setFlag("AA", 7, self.session.session_time)
            self.Assisting = 2

        #print str(self.Assisting)
        if self.Assisting > -100:
            self.AutoAssist()


        self.TSIC.viewUpdate()  
        self.TSIC.imageUpdate(self.session)
        
        #print str(self.session.alarm)


        #topbar
        st_s=str(round(self.session.sud,1))
        if len(st_s)==1:
            st_s = st_s + ".0"
        self.setWindowTitle('Patient '+ self.session.patientLetter + "  -  " + st_s )

        if self.session.therapy == "Social":

            self.w_sc.hide()
            self.w_sc2.show()

        if self.speed == 0:
            self.w_lock.show()
        else:
            self.w_lock.hide()


    def setAlarm(self):
         self.w_warning.w_w.sec = 15
         self.w_warning.show()
         self.TSIC.playAlarm()

    def AutoAssist(self):


        self.Assisting = self.Assisting - 1

        if self.Assisting <0 and self.Assisting >-100:


            s = self.session.sudAlarm
            hs =  self.session.sudAlarm +2

            if self.session.sud<s:
                self.Assisting = -101
                self.session.alarm=False

            if self.session.sud>=s and self.session.sud<hs:
                self.session.AdjustSimulation2("A",3,    -2,10,   "",1,""    , 0, "")
                self.Assisting = 12

            if self.session.sud>=hs:
                self.session.AdjustSimulation2("A",1,     -5,30, "",1,           "", 0,"")
                self.Assisting = 25




    def fiveSecUpdate(self):

        temp = round(self.session.sud2,1)
        temp2 = self.session.session_time
        self.commandOut("SUD#"+ str(temp) + "#" + str(temp2+1) )

        self.session.talkUpdate()


    def keyPressEvent(self, event):

        key = event.key()
        if key == QtCore.Qt.Key_F9:
            self.SetFullScreen()
        if key == QtCore.Qt.Key_F5:
            self.tpvw.show()

        elif key == QtCore.Qt.Key_Escape:
            self.flag_fullscreen = True
            self.SetFullScreen()




        else:
            #QtGui.QWidget.keyPressEvent(self, event)
            pass


    def SetFullScreen(self):
        if self.flag_fullscreen == False:
            self.showFullScreen()
            self.flag_fullscreen = True
        elif self.flag_fullscreen == True:
            self.showNormal()
            self.flag_fullscreen = False

    def stopAssit(self):
        self.session.Lock_talkToPatient=0
        self.commandOut("LOCKP#0")
        self.session.reverseLastEA()

    def localAssit(self):
        self.session.sud=3.5
        self.session.adjustArray = []
        self.session.Lock_talkToPatient = 20
        self.session.Lock_scenario = 20
        self.session.setFlag("RA", 8, self.session.session_time)


    def resizeEvent (self, QResizeEvent):
        size = self.size()
        self.w = size.width()
        self.h = size.height()
        #self.wid9.move(10, self.h-220)
        #self.wid9.resize(self.w-22,100)


        self.w_warning.resize(self.w,self.h)
        self.w_lock.resize(self.w,self.h)

        tw = (self.w/2) - 380
        th = (self.h/2) - 350

        self.w_workload.move(tw,th)


        self.w_stl.move(10, self.h-240)
        self.w_stl.resize(self.w-22,230)

        self.w_nc.move(self.w-782, 10)

        self.w_sc.move(self.w-572, 10)
        self.w_sc2.move(self.w-572, 10)

        self.w_pc.move(self.w-362, 10)


        self.w_ac.move(self.w-152, 10)

        self.w_pt.move(220, 270)
        self.w_pt.resize(self.w-232,40)

        if self.h > 680:
            hh= self.h-563
            self.w_vwView.move(10,320)
            self.w_vwView.resize(hh*1.29,hh)

            #self.w_pView.move(22+(hh*1.29),320)
            #self.w_pView.resize(hh*1.29,hh)

            temp = 22+(hh*1.29)
            self.w_assist.move(temp,320)
            self.w_assist.resize(self.w -temp -11,hh)

        else:
            self.w_vwView.move(-100,-100)
            self.w_vwView.resize(10,10)
            #self.w_pView.move(-100,-100)
            #self.w_pView.resize(10,10)
            self.w_assist.move(-100,-100)
            self.w_assist.resize(10,10)

        if self.w > 1190:
            self.w_notes.move(220,10)
            self.w_notes.resize(self.w-1012,250)
        else:
            self.w_notes.resize(10,10)
            self.w_notes.move(-100,-100)

#---------------------connecetions

    def commandIn(self,text):

        print "C - In: " + text

        #if text == "GENERAL+++":
        #    self.SetFullScreen()
        #
        #
        #if text == "UPDATE+++":
        #    self.session.update()


        if text == "WORK":
            self.w_workload.show()
            self.speed = 0


        if text == "RESET":
            self.session.reset()

        if text == "ASSIST":
            self.session.assist=True

        if text == "NOASSIST":
            self.session.assist=False

        if text == "START":
            self.session.status="Started"


        if text == "SWITCH":
            #self.session.status="Ended"
            self.session.reset()

        if text == "PATIENT":
            #self.session.status="Ended"
            self.session.reset()

        text2= text.split('#')


        if (len(text2)) == 2:

          if text2[0] =="SETTIME":
                try:
                    ret1 = int(text2[1])
                except ValueError:
                    ret1 = -1
                if ret1>-1:
                    self.session.session_time = ret1



          if text2[0] =="SUD":
                try:
                    ret1 = float(text2[1])
                except ValueError:
                    ret1 = -1
                if ret1>-1:
                    self.session.sud = ret1
                    self.session.sud2 = ret1


          if text2[0] =="SETLENGTH":
                try:
                    ret1 = int(text2[1])
                except ValueError:
                    ret1 = -1
                if ret1>-1:
                    self.session.session_time_total = ret1


          if text2[0] =="SPEED":
              try:
                  ret = float(text2[1])
              except ValueError:
                  ret = -1

              if ret>-1:
                  self.speed = ret


          if text2[0] =="LOCKP":
              try:
                  ret1 = float(text2[1])
              except ValueError:
                  ret1 = -1
              if ret1>-1:
                  self.session.Lock_talkToPatient = ret1



          if text2[0] =="LOCKS":
              try:
                  ret1 = float(text2[1])
              except ValueError:
                  ret1 = -1
              if ret1>-1:
                  self.session.Lock_scenario = ret1


        if (len(text2)) == 3:

          if text2[0] =="SETPATIENT":
              try:
                  ret1 = (text2[1])
              except ValueError:
                  ret1 = -1
              try:
                  ret2 = (text2[2])
              except ValueError:
                  ret2 = -1
              self.session.patientLetter= ret1
              self.session.patientName= ret2

          if text2[0] =="SETTHERAPY":
              try:
                  ret1 = int(text2[1])
              except ValueError:
                  ret1 = -1
              try:
                  ret2 = (text2[2])
              except ValueError:
                  ret2 = -1
              self.session.number= ret1
              self.session.therapy= ret2



        if (len(text2)) == 4:
          if text2[0] =="ADJUST":
              try:
                  ret1 = float(text2[1])
                  ret1 = int(ret1)
              except ValueError:
                  ret1 = -1
              try:
                  ret2 = int(text2[2])
              except ValueError:
                  ret2 = -1
              try:
                  ret3 = str(text2[3])
              except ValueError:
                  ret3 = -1

              self.session.ajustSud(ret1,ret2,ret3)


    def commandOut(self, text):
        if self.connected=="Connected":

            print "C - Out: " + text
            self.Conn_out.sendCommand(text)
            

    def addConnection(self):

        send = False            #self.w_conn.checkBox.checkState()
        if send==0:
            send = False
        else:
            send = True
        #send = self.w_conn.bier
        #print str(send)

        port = self.w_conn.input_port.displayText()
        #print str(port)
        port=int(port)
        host = self.w_conn.input_host.displayText()

        self.Conn_in= MyConnection(send, host,port)

        if send==False:
            send = True
        else:
            send = False

        self.Conn_out = MyConnection(send,host,port+1)

        #for i in range(len(self.sessionWindowArray)):
        #    self.sessionWindowArray[i].start()
        #self.ConnectionsArray.

        self.connected="Looking"



class TherapistPatientViewWindow(QtGui.QMainWindow):
    def __init__(self,sessionControl):
        QtGui.QMainWindow.__init__(self)

        self.setMinimumSize(300, 240)
        #window
        self.resize(300, 240)
        self.setWindowTitle('View')
        self.setAutoFillBackground ( True )
        self.sessionControl = sessionControl
        #self.setWindowOpacity(0.5)

        self.test = 0

        #white back groung
        size = self.size()
        self.w = size.width()
        self.h = size.height()

        self.w_back = w_black(self)
        self.w_back.move(0, 0)
        #self.wid10.resize(w,h-55)
        self.w_back.resize(2000,2000)
        
        #varables:
        self.flag_fullscreen = False

        self.w_pView = w_view2(self, QtGui.QPixmap("res/ruis.jpg"), "Patient View")
        self.w_pView.setWindowOpacity(0.5)


    def Update(self):
        #update every senario second

        self.w_pView.repaint()

    def resizeEvent (self, QResizeEvent):
        size = self.size()
        self.w = size.width()
        self.h = size.height()
        #self.wid9.move(10, self.h-220)
        #self.wid9.resize(self.w-22,100)

        t =   self.w  -   ((self.h)*1.6)
        t=t/2

        self.w_pView.move(t, 0)
        self.w_pView.resize((self.h)*1.6,self.h)

    def keyPressEvent(self, event):

        key = event.key()
        if key == QtCore.Qt.Key_F9:
            self.SetFullScreen()
        elif key == QtCore.Qt.Key_Escape:
            self.flag_fullscreen = True
            self.SetFullScreen()
            self.session.image = "sud2"
        else:
            #QtGui.QWidget.keyPressEvent(self, event)
            pass

    def SetFullScreen(self):
        if self.flag_fullscreen == False:
            self.showFullScreen()
            self.flag_fullscreen = True
        elif self.flag_fullscreen == True:
            self.showNormal()
            self.flag_fullscreen = False



#Run Aplication
app = QtGui.QApplication(sys.argv)

main = TherapistSessionWindow()
main.show()

sys.exit(app.exec_())

